#include <stdio.h>
#include <string.h>
#include <io.h>
#include <conio.h>
#include <dos.h>
#include <mem.h>
#include <time.h>
#include <process.h>
#include <sys/farptr.h>
#include <sys/movedata.h>
#include <sys/segments.h>
#include <pc.h>
#include <dpmi.h>
#include <go32.h>
#include <ctype.h>
#include <dir.h>
#include <bios.h>
#include <unistd.h>
#include <errno.h>


unsigned short B800;

unsigned char CursorStartLine;
unsigned char CursorEndLine;

unsigned char MZCGROM[0x2000 - 0x1000];
unsigned char MZCGRAM[0xD000 - 0xC000];




void InitVGA(void)
{
 union REGS Register;

 // mode 1, 40 x 25 colour mode
 // with MSB set, the screen is not cleared
 Register.w.ax = 0x0081;
 int86(0x10, &Register, &Register);

 // activate page 0
 Register.w.ax = 0x0500;
 int86(0x10, &Register, &Register);
}




void ReInitVGA(void)
{
 union REGS Register;

 // 80 x 25 colour mode
 Register.w.ax = 0x0003;
 int86(0x10, &Register, &Register);

 // restore the original ROM font of the graphic card
 Register.w.ax = 0x1114;
 Register.w.bx = 0;
 int86(0x10, &Register, &Register);
}




char Mirror(char Byte)
{
 unsigned char SetMask = 0x80;
 unsigned char GetMask = 0x01;
 unsigned char i;
 char Result = 0;


 for(i = 0; i < 8; i++)
 {
  if((Byte & GetMask) != 0) Result = Result | SetMask;
  SetMask = SetMask >> 1;
  GetMask = GetMask << 1;
 }

 return Result;
}




void CGRAMToVGA(void)
{
 /*
  *  Copy the MZ-CharacterFont (CG-RAM) into the VGA-Card
  *
  */

 __dpmi_regs Register;
 unsigned char MZMirrorCGRAM[4096];
 unsigned short i;

 for(i = 0; i < 4096; i++) MZMirrorCGRAM[i] = Mirror(MZCGRAM[i]);


 dosmemput(&MZMirrorCGRAM[0], 0x800, __tb);

 Register.h.ah = 0x11;
 Register.h.al = 0x10;  // install and activate the new set
 Register.h.bh = 8;     // 8 scan lines
 Register.h.bl = 0;     // in table 0
 Register.x.cx = 256;   // 256 characters
 Register.x.dx = 0;     // first character is ASCII 0
 Register.x.es = __tb >> 4;
 Register.x.bp = __tb & 0x0F;
 __dpmi_int(0x10, &Register);


/*
 dosmemput(&MZMirrorCGRAM[0x800], 0x800, __tb);

 Register.h.ah = 0x11;
 Register.h.al = 0x00;  // install only
 Register.h.bh = 8;     // 8 scan lines
 Register.h.bl = 1;     // in table 1
 Register.x.cx = 256;   // 256 characters
 Register.x.dx = 0;     // first character is ASCII 0
 Register.x.es = __tb >> 4;
 Register.x.bp = __tb & 0x0F;
 __dpmi_int(0x10, &Register);
*/
}




void LoadCGROM(char *FileName) {
 FILE *pROM;
 unsigned short i;


 if((pROM = fopen(FileName, "rb")) != NULL)
 {
  fread(MZCGROM, sizeof(char), 4096, pROM);
  fclose(pROM);

  for(i = 0; i < 4096; i++) MZCGROM[i] = Mirror(MZCGROM[i]);

  memcpy(MZCGRAM, MZCGROM, 4096);

  CGRAMToVGA();
 }
 else
 {
  ReInitVGA();
  printf("Can not open %s !\n", FileName);
  exit(1);
 }
}




int main(int argc, char *argv[])
{
 int i;


 B800 = __dpmi_segment_to_descriptor(0xB800);

 InitVGA();                             // change video mode

 if(argc == 1) {
	// clear screen
  for(i = 0; i < (40 * 25); i ++){
    _farpokeb(B800, i << 1, ' ');
    _farpokeb(B800, (i << 1) + 1, 0x71);
	}
  
  
  for(i = 0; i < 25; i++) {
   if(i < 10) _farpokeb(B800, (i * 40) << 1, '0' + i);
   else if (i < 20){
    _farpokeb(B800, (i * 40) << 1, '1');
    _farpokeb(B800, (i * 40 + 1) << 1, '0' + i % 10);
   }
   else {
    _farpokeb(B800, (i * 40) << 1, '2');
    _farpokeb(B800, (i * 40 + 1) << 1, '0' + i % 20);
   }
  }
 } else {
  LoadCGROM("MZ7CGInt.ROM");
  
  //clear screen
  for(i = 0; i < (40 * 25); i ++){
	 _farpokeb(B800, i << 1, 0);
   _farpokeb(B800, (i << 1) + 1, 0x17);
  }
  
  for(i = 0; i < 25; i++) {
   if(i < 10) _farpokeb(B800, (i * 40) << 1, 0x20 + i);
   else if (i < 20){
    _farpokeb(B800, (i * 40) << 1, 0x21);
    _farpokeb(B800, (i * 40 + 1) << 1, 0x20 + i % 10);
   }
   else {
    _farpokeb(B800, (i * 40) << 1, 0x22);
    _farpokeb(B800, (i * 40 + 1) << 1, 0x20 + i % 20);
   }
  }  
 }

 sleep(3);


 ReInitVGA();           // restore the original textmode

 return 0;
}

